> This page is for Developer Documentation.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.benchling.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.benchling.com/_mcp/server.

# List Features

GET https://{tenant_name}.benchling.com/api/v2/features

List Features

Reference: https://docs.benchling.com/docs/api/v2/benchling-api/feature-libraries/list-features

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Query parameters

- `pageSize` (integer, optional, default: 50) — Number of results to return. Defaults to 50, maximum of 100.
- `nextToken` (string, optional) — Token for pagination
- `name` (string, optional) — Name of a Feature. Restricts results to those with the specified name.
- `ids` (string, optional) — Comma-separated list of ids. Matches all of the provided IDs, or returns a 400 error that includes a list of which IDs are invalid.
- `names.anyOf.caseSensitive` (string, optional) — Comma-separated list of names. Maximum of 100. Restricts results to those that match any of the specified names.
- `featureLibraryId` (string, optional) — Id of a Feature Library. Restricts results to those associated with the provided feature library
- `featureType` (string, optional) — The type of feature, like gene, promoter, etc. Note: This is an arbitrary string, not an enum
- `matchType` (enum, optional) — The match type of the feature used to determine how auto-annotate matches are made.
  - Allowed values: `nucleotide`, `protein`
- `returning` (string, optional) — Comma-separated list of fields to return. Modifies the output shape. To return all keys at a given level, enumerate them or use the wildcard, '*'. For more information, [click here](https://docs.benchling.com/docs/getting-started-1#returning-query-parameter).

## Response

### 200

OK

- `nextToken` (string, optional)
- `features` (list of Feature, optional) — List of features for the page

## Errors

### 400 Bad Request Error

Bad Request

- `error` (BadRequestErrorError, optional)

## Types

### Feature

A feature from a feature library

- `color` (string, optional) — The color of the annotations generated by the feature. Must be a valid hex string
- `featureLibraryId` (string, optional) — The id of the feature library the feature belongs to
- `featureType` (string, optional, nullable) — The type of feature, like gene, promoter, etc. Note: This is an arbitrary string, not an enum
- `name` (string, optional) — The name of the feature
- `pattern` (string, optional) — The pattern used for matching during auto-annotation.
- `id` (string, optional) — The id of the feature
- `matchType` (enum, optional) — The match type of the feature. Used to determine how auto-annotate matches are made.
  - Allowed values: `nucleotide`, `protein`

### BadRequestErrorError

- `message` (string, optional)
- `type` (enum, optional)
  - Allowed values: `invalid_request_error`
- `userMessage` (string, optional)

## Examples

**Response**

```json
{
  "nextToken": "string",
  "features": [
    {
      "color": "#F58A5E",
      "featureLibraryId": "featlib_19kd9aDq",
      "featureType": "string",
      "name": "string",
      "pattern": "string",
      "id": "feat_4YVqX98z",
      "matchType": "nucleotide"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://{tenant_name}.benchling.com/api/v2/features"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://{tenant_name}.benchling.com/api/v2/features';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```